"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from enum import Enum
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel


class SafeUpdate(str, Enum):
    r"""Enable safe update mode to prevent collisions"""

    TRUE = "true"
    FALSE = "false"


class SafeTagsRequestTypedDict(TypedDict):
    tags: List[str]
    r"""An array of tag strings to add or set"""
    updated_stamp: NotRequired[datetime]
    r"""The ticket's latest updated_at timestamp for safe updates.
    Must match the current timestamp to prevent collision.

    """
    safe_update: NotRequired[SafeUpdate]
    r"""Enable safe update mode to prevent collisions"""


class SafeTagsRequest(BaseModel):
    tags: List[str]
    r"""An array of tag strings to add or set"""

    updated_stamp: Optional[datetime] = None
    r"""The ticket's latest updated_at timestamp for safe updates.
    Must match the current timestamp to prevent collision.

    """

    safe_update: Optional[SafeUpdate] = None
    r"""Enable safe update mode to prevent collisions"""
